/*
	sjis2utf8
	
	sjis  UTF-8ɕϊAASCIIR[hɕϊ
	s FALSE
	
	Ql http://homepage1.nifty.com/yt-works/prog/utf8/utf8.html
*/
#include<stdio.h>
#include<ctype.h>
#include<stdlib.h>
#include<windows.h>

int sjis2utf8(const char * ssrc,unsigned char * sdst,int idstsz)
{
	int i , n , ires;
	char buf[8];
	LPWSTR wbuf;
	unsigned char *putf;
	
	// unicode֕ϊ
	
	// O`FbN
	ires = MultiByteToWideChar(CP_ACP , 0 , ssrc , -1 , NULL , 0);
	if ( ires == 0 ) return FALSE;
	
	// [N擾
	wbuf = malloc(ires*2+1);
	if (wbuf == NULL) return FALSE;
	
	// ϊ
	ires = MultiByteToWideChar(CP_ACP,0,ssrc,-1,wbuf,ires);
	wbuf[ires]  = 0;
	if (ires == 0) return FALSE;
	
	// UTF8ւ̕ϊ
	// O`FbN
	ires = WideCharToMultiByte(CP_UTF8,0,wbuf,-1,NULL,0,NULL,NULL);
	if (ires == 0){
		free(wbuf);
		return FALSE;
	}
	
	// eʃ`FbN
	if (idstsz == 0){
		free(wbuf);
		return FALSE;
	}
	
	// ̈m
	putf = malloc(ires+1);
	if (putf == NULL){
		free(wbuf);
		return FALSE;
	}
		
	// ϊ
	ires = WideCharToMultiByte(CP_UTF8,0,wbuf,-1,putf,ires,NULL,NULL);
	if (ires == 0){
		free(wbuf);
		free(putf);
		return FALSE;
	}
	
	n = sdst[0] = 0;//
	while(putf[n] != 0){
		//ŏʃrbg1łutf8Ɣf
		if(putf[n] >> 7 == 1 || !isalnum(putf[n])){
			sprintf(buf , "%%%x" , putf[n]);
			CharUpper(buf);
		}else{
			sprintf(buf , "%c" , putf[n]);
		}
		strcat(sdst , buf);
		n++;
	}
	
	free(putf);
	free(wbuf);
	
	return TRUE;
}
